/* class_list.h - template class "list" for CLASHA v0.2

 Copyright (c) 2014 A.A.Shabarshin <me@shaos.net>

 Permission is hereby granted, free of charge, to any person obtaining
 a copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute, sublicense,
 and/or sell copies of the Software, and to permit persons to whom
 the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
*/

#include "clasha.h"

/* to have your own list class define TEMPCLASS and TEMPLATE externally */

#ifdef TEMPCLASS
#define CLASS TEMPCLASS
#else
#define CLASS List
#define TEMPLATE int id;
#endif

BEGIN
 TEMPLATE
 void* next;
END

#ifndef LIST_DEFAULT
#define LIST_DEFAULT    0
#define LIST_COPYCON   -1
#endif

PUBLIC unsigned int METHOD(size) (void);
PUBLIC CLASS* METHOD(first) (CLASS *this);
PUBLIC CLASS* METHOD(last) (CLASS *this);
PUBLIC int METHOD(deleteall) (CLASS *this);
PUBLIC int METHOD(count) (CLASS *this);
PUBLIC int METHOD(index) (CLASS *this, CLASS *elem);
PUBLIC CLASS* METHOD(get) (CLASS *this, int n);
PUBLIC CLASS* METHOD(prepend) (CLASS *this, CLASS *tail);
PUBLIC CLASS* METHOD(append) (CLASS *this, CLASS *tail);
PUBLIC CLASS* METHOD(remove) (CLASS *this, CLASS *elem);
PUBLIC CLASS* METHOD(insert) (CLASS *this, CLASS *elem, CLASS *prev);
PUBLIC CLASS* METHOD(insertas) (CLASS *this, CLASS *elem, int n);
PUBLIC CLASS* METHOD(findlike) (CLASS *this, void *data);
PUBLIC CLASS* METHOD(findlikepart) (CLASS *this, void *data, int offset, unsigned int size);
